.data
start_msg:      .asciiz "List before: "
end_msg:        .asciiz "List after: "

.text
.globl jmain               
jmain:                     
  addiu   $sp, $sp, -4     # store $ra onto the stack
  sw      $ra, 0($sp)      #

  addiu   $sp, $sp, -4     ## create the list
  sw      $a0, 0($sp)      #
  jal     create_default_list  #
  lw      $a0, 0($sp)      #
  addiu   $sp, $sp,  4     #

  addiu   $sp, $sp, -8     # save s0 and s1
  sw      $s0, 0($sp)      #
  sw      $s1, 4($sp)      #

  add     $s0, $a0, $0     # s0 = a0 
  add     $s1, $v0, $0     # s1 = v0

  la      $a0, start_msg   # print "list before: "
  li      $v0, 4           #
  syscall                  #

  addu    $a0, $s1, $0     # print the list
  jal     print_list       #
  jal     print_newline    # print a newline

  add     $a0, $s0, $0     # a0 = s0 
  add     $v0, $s1, $0     # v0 = s1

  lw      $s0, 0($sp)      # restore s0 and s1
  lw      $s1, 4($sp)      #
  addiu   $sp, $sp, 8      #

  bne $a0, $0, ELSE        ## select the function to call
  la  $a1, square          # a1 = address of square function
  j CALLMAP                #
ELSE:                      #
  addi $a0, $a0, -1        #
  bne $a0, $0, ELSE2       #
  la  $a1, double          # a1 = address of double function
  j CALLMAP                #
ELSE2:                     #
  la $a1, half             # a1 = address of half function

CALLMAP:
  add   $a0, $0, $v0       # copy the list's head into $a0 from $v0

  addiu $sp, $sp, -4       # call the map func
  sw    $a0, 0($sp)        #
  jal   map                #
  lw    $a0, 0($sp)        #
  addiu $sp, $sp, 4        #

  add $v0, $0, $a0         # copy back the head of list into $v0

  addiu   $sp, $sp, -4     # save s0
  sw      $s0, 0($sp)      #
  add     $s0, $v0, $0     # s0 = v0 

  la      $a0, end_msg     # print "list after: "
  li      $v0, 4           #
  syscall                  #

  addu    $a0, $s0, $0     # print the list
  jal     print_list       #
  jal     print_newline    # print a newline

  add     $v0, $s0, $0     # v0 = s0 

  lw      $s0, 0($sp)      # restore s0
  addiu   $sp, $sp, 4      # 

  lw $ra, 0($sp)           # restore $ra from the stack and return
  addiu $sp, $sp, 4        #

  jr $ra                   # <<< Comment this instruction under MARS
  li      $v0, 10          # end execution of the program in MARS 
  syscall                  #

create_default_list:
  addiu $sp, $sp, -4       # store $ra on the stack
  sw    $ra, 0($sp)        #

  addi  $s0, $0, 0         # pointer to the last node we handled
  addi  $s1, $0, 0         # number of nodes we handled

_loop:                     # do
  addi  $a0, $0, 8         #   size of memory to allocate
  jal   malloc             #   allocate memory
  sw    $s1, 0($v0)        #   node->value = i
  sw    $s0, 4($v0)        #   node->next = last
  addu  $s0, $0, $v0       #   last = node
  addiu $s1, $s1, 1        #   i++
  bne   $s1, 10, _loop     # while i != 10

  lw    $ra, 0($sp)        # restore $ra from the stack and return
  addiu $sp, $sp, 4        #
  jr    $ra                #

malloc:                    # function: allocate memory
  addi  $v0, $0, 9         #
  syscall                  #
  jr    $ra                #

square:                    # function: square
  mul   $v0, $a0, $a0      #
  jr    $ra                #

double:                    # function: double
  add   $v0, $a0, $a0      #
  jr    $ra                #

half:                      # function: half
  sra   $v0, $a0, 1        #
  jr    $ra                #

print_list:
  bne   $a0, $0, printMeAndRecurse
  jr    $ra                # nothing to print

printMeAndRecurse:
  addu  $t0, $a0, $0       # t0 gets current node address
  lw    $a0, 0($t0)        # a0 gets value in current node
  li    $v0, 1             # preparte for print integer syscall
  syscall
  li      $a0, ' '         # a0 gets address of string containing space
  li      $v0, 11          # prepare for print string syscall
  syscall
  lw      $a0, 4($t0)      # a0 gets address of next node
  j       print_list       # recurse. We don't have to use jal because we already have where we want to return to >

print_newline:
  li      $a0, '\n'
  li      $v0, 11
  syscall
  jr      $ra
