.data
arrays: .word 5, 6, 7, 8, 9		
        .word 1, 2, 3, 4, 7
        .word 5, 2, 7, 4, 3
        .word 1, 6, 3, 8, 4
        .word 5, 2, 7, 8, 1
		
start_msg: .asciiz "Lists before: \n"
end_msg:   .asciiz "Lists after: \n"

.text
  la   $a0, arrays          # $a0 = "arrays" address
  addi $a1, $0, 5           # $a1 = number of elements in the array in a node
  addi $a2, $0, 5           # $a2 = number of nodes (=nbr of lines in "arrays")
  addi $a3, $0, 0           # $a3 = index of the function to execute (here, mystery function)
 
.globl jmain
jmain:
  addi $sp, $sp, -12        # store on the stack 
  sw   $ra, 0($sp)          #    $ra
  sw   $s0, 4($sp)          #    $s0
  sw   $s1, 8($sp)          #    $s1

  move $s0, $a3             # $s0 = $a3

  jal create_default_list
  move $s1, $v0	            # assign to $s1 the 'head' pointer of the linked list 

  la   $a0, start_msg       # print "listes before: "
  li   $v0, 4               #
  syscall                   #

  addu $a0, $s1, $0         # print the list
  jal  print_list           # 

  jal  print_newline        # print a newline

  ## select the function to call
  bne  $s0, $0, ELSE
  la   $a1, mystery         # select  the "mystery function"
  j    CALLMAP
ELSE:
  addi $s0, $s0, -1
  bne  $s0, $0, ELSE2
  la   $a1, double          # select the "double function"
  j    CALLMAP
ELSE2:
  la   $a1, half            # select the "half function"

CALLMAP:
  move $a0, $s1
  jal  map

	
  la   $a0, end_msg         # print "lists after: "
  li   $v0, 4               #
  syscall                   #

  addu $a0, $s1, $0         # print the list

  jal  print_list

  move $v0, $s1             # $v0 = $s1

  lw   $s1, 8($sp)          #  restore $s1
  lw   $s0, 4($sp)          #     "    $s0
  lw   $ra, 0($sp)          #     "    $ra
  addi $sp, $sp, 12         #  from the stack
  
  jr   $ra                  # <<< Comment this line under MARS
  li   $v0, 10              # quit the program under MARS 
  syscall                   #


mystery:
  mul   $v0, $a0, $a0
  add   $v0, $v0, $a0
  jr    $ra

double:
  add   $v0, $a0, $a0
  jr    $ra

half:
  sra   $v0, $a0, 1
  jr    $ra

print_list:
  bne   $a0, $0, printMeAndRecurse
  jr    $ra                  # nothing to print

printMeAndRecurse:
  move  $t0, $a0             # $t0 gets address of current node
  lw    $t3, 0($a0)          # $t3 gets array of current node
  lw    $t7, 4($a0)          # $t7 size of array in current node
  li    $t1, 0		           # $t1 is index into array
printLoop:
  sll   $t2, $t1, 2
  addu  $t4, $t3, $t2
  lw    $a0, 0($t4)          # $a0 gets value in current node's array at index $t1
  li    $v0, 1               # prepare for print integer syscall
  syscall
  li    $a0, ' '             # $a0 gets address of string containing space
  li    $v0, 11              # prepare for print string syscall
  syscall
  addiu $t1, $t1, 1
  bne   $t1, $t7, printLoop
  li    $a0, '\n'	
  li    $v0, 11
  syscall
  lw    $a0, 8($t0)          # $a0 gets address of next node
  j     print_list           # recurse. We don't have to use jal because we already have where we want to return to in $ra

print_newline:
  li    $a0, '\n'
  li    $v0, 11
  syscall
  jr    $ra
